#!/usr/bin/env python
# -*- coding: utf-8 -*-

# twisted import
from twisted.python import log

class RpcMessage(object):
    """
    """

    def __init__(self, message, definition=None):
        """
        """
        # set message value
        if message is None:
            self.message = {}
        else:
            self.message = message
        # set message definition
        if definition is None:
            self.definition = {}
        else:
            self.definition = definition

    def get(self, key):
        """
        """
        if self.definition is None:
            # return str by default
            return self.get_val(key)
        else:
            if self.definition[key] is bool:
                return self.get_bool(key)
            elif self.definition[key] is int:
                return self.get_int(key)
            elif self.definition[key] is list:
                return self.get_list(key)
            # default str
            else:
                return self.get_val(key)

    def get_dict(self):
        """
        """
        # init result dict
        _r_dict = dict()
        #
        for _k, _v in self.message.items():
            _r_dict[_k] = self.get_val(_k)
        # return dict
        return _r_dict

    def has_key(self, key):
        """
        """
        return self.message.has_key(key)

    def get_val(self, key):
        """
        """
        if self.message.has_key(key):
            return self.message[key][0].strip()
        else:
            return None

    def get_bool(self, key):
        """
        """
        # get str val first
        _val = self.get_val(key)
        return _val == "True" or _val == "true" or _val == "1"

    def get_int(self, key):
        """
        """
        # get str val first
        _val = self.get_val(key)
        try:
            return int(_val)
        except Exception, e:
            # ERROR
            log.err("[RpcMessage] get_int - %s|%s e: %s" \
                    % (self.message, key, e))
            # return str by default
            return None

    def get_list(self, key):
        """
        """
        if self.message.has_key(key):
            return self.message[key]
        else:
            return []

