#!/usr/bin/env python
# -*- coding: utf-8 -*-

# nevow import
from nevow import tags as T
from nevow.i18n import _

# bewype ui import
from bewype.core.ui.editable import Editable
from bewype.core.ui.widget import Widget

# Entry
class Entry(Widget, Editable):

    def __init__(self, id_=None, class_=None, name=None,
            type_="text", value=None, readonly=False,
            max_length=None, markup=None):
        Editable.__init__(self)
        Widget.__init__(self, id_=id_, class_=class_)
        # Attributes
        if name is None:
            self.name = self.id_
        else:
            self.name = name
        #
        self.max_length = max_length
        #
        self.readonly = readonly
        #
        self.type_ = type_
        # content
        self.value = value
        self.markup = markup

    def get_docFactory(self):
        # set html readonly value
        if self.readonly is True:
            _readonly = "readonly"
        else:
            _readonly = None
        #  specific 
        return T.input(id_=self.id_, class_=self.class_,
                name=self.name, maxlength=self.max_length, type_=self.type_,
                value=self.value, alt=self.markup, readonly=_readonly)

    def set_visible(self, readonly):
        self.readonly = readonly

    def get_visible(self):
        return readonly

    def set_max_length(self, max_length):
        self.max_length = max_length

    def get_max_length(self):
        return self.max_length

    def set_text(self, text):
        self.text = text

    def get_text(self):
        return self.text

    def get_text_length(self):
        return len(self.text)

