#!/usr/bin/env python
# -*- coding: utf-8 -*-

# python import
from functools import partial

# nevow import
from nevow import tags as T

# bewype import
from bewype.core.ui.bin import Bin
from bewype.core.ui.container import get_attr_factory
from bewype.core.ui.label import Label

class Frame(Bin):

    def __init__(self, id_=None, class_=None, label=None, label_widget=None,
            display=True):
        Bin.__init__(self, id_=id_, class_=class_)
        # Label
        self.label = label
        self.label_widget = label_widget
        # simple style useful value
        self.display = display

    def _realize_label(self):
        if self.label_widget is None and self.label is None:
            return
        if self.label_widget is None:
            # create widget
            self.label_widget = Label(class_=self.class_, text=self.label,
                    tag=T.h1)
        else:
            pass
        # update widget list
        self.widgets.insert(0, self.label_widget)

    def get_docFactory(self):
        if len(self.widgets) == 0:
            return ""
        else:
            # prepare label
            self._realize_label()
            # ensure html style value
            if self.display is True:
                _display = None
            else:
                _display = "display: none"
            # return div
            return T.div(id=self.id_, class_=self.class_, style=_display)[
                    map(get_attr_factory, self.widgets)
                    ]

    def set_label(self, label):
        self.label = label

    def get_label(self):
        return self.label

    def set_label_widget(self, label_widget):
        self.label_widget = label_widget

    def get_label_widget(self):
        return self.label_widget

    def set_display(self, display):
        self.display = display

    def get_display(self):
        return self.display

