#!/usr/bin/env python
# -*- coding: utf-8 -*-

# nevow import
from nevow import tags as T

# bewype ui import
from bewype.core.ui.widget import Widget

class Label(Widget):

    def __init__(self, id_=None, class_=None, text=None, href=None,
            markup=None, name=None, tag=None):
        Widget.__init__(self, id_=id_, class_=class_)
        #
        self.text = text
        self.markup = markup
        self.href = href
        #
        if name is None and self.class_ is not None:
            self.name = self.class_.lower()
        else:
            self.name = name
        #
        self.tag = tag

    def get_docFactory(self):
        if self.tag is None:
            return T.a(id=self.id_, class_=self.class_, name=self.name,
                    alt=self.markup, href=self.href)[self.text]
        else:
            return self.tag(id=self.id_, class_=self.class_,
                    name=self.name, alt=self.markup)[self.text]

    def set_text(self, text):
        self.text = text

    def get_text(self):
        return self.text

    def set_markup(self, markup):
        self.markup = markup

    def get_markup(self):
        return self.markup

    def set_href(self, href):
        self.href = href

    def get_href(self):
        return self.href

    def set_name(self, name):
        self.name = name

    def get_href(self):
        return self.name

