#!/usr/bin/env python
# -*- coding: utf-8 -*-

# nevow import
from nevow import loaders, tags as T

# bewype ui import
from bewype.core.ui.widget import Widget

class ReCaptcha(Widget):

    def __init__(self, id_=None, class_=None, auth_url=None, public_key=None,
            lang="en", theme="red"):
        # init parent
        Widget.__init__(self, id_=id_, class_=class_)
        # auth vars
        self.auth_url = auth_url
        self.public_key = public_key
        # theme vars
        self.theme = theme
        self.lang = lang

    def get_docFactory(self):
        # get option doc
        _script_options_doc = T.script()[
        """
        var RecaptchaOptions = {
                theme: '%s',
                lang: '%s'
                };
        """ % (self.theme, self.lang)
        ]
        # prepare script src url
        _script_src = "%s?k=%s" % (self.auth_url, self.public_key)
        _script_doc = T.script(
                type="text/javascript",
                src=_script_src
                )
         # prepare no script src url
        _no_script_src = "%s/noscript?k=%s" % (self.auth_url, self.public_key)
        # init no script doc
        _no_script_doc = T.noscript()[
                T.iframe(
                    src=_no_script_src,
                    height="300",
                    width="500",
                    frameborder="0"
                    )
                ]
        return T.div(id_=self.id_, class_=self.class_)[
                _script_options_doc, _script_doc, _no_script_doc
                ]

