
/**
 *
 */
BewypeJS.Component.ColorPicker = new Class(
{
    // parent class
    Extends: BewypeJS.Component,

   /**
     *
     */
    initialize: function (widgetName, widgetId, groupId, valueKey)
    {
        // init parent
        this.actionList = ["Add", "Cancel", "Edit", "Update", "Reload"];
        this.parent(widgetName, widgetId, groupId, valueKey);
        // set specific field id
        this.fieldId = this.widgetId + "PickerImage";
        // get date picker
        this.colorPicker = this._getColorPicker();
        this.displayed = false;
    },

    _onChange: function (hsb, hex, rgb)
    {
        BewypeJS.Utils.updateField(this.fieldId, "#" + hex);
        // update image color
        jQuery("#" + this.fieldId + "Div div").css("backgroundColor", "#" + hex);
    },

    _getColorPicker: function ()
    {
        // get date picker params
        var _pickerParams =  { onChange: this._onChange };
        // create new picker in calendar element
        return jQuery("#" + this.fieldId + "Div").ColorPicker(_pickerParams);
    },

    resultCb: function (linkElement, params, result)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            // ?? pass
        }
        else if(_action == "Cancel"
                || _action == "Edit"
                || _action == "Reload")
        {
            // get content
            var _value = BewypeJS.Utils.getVal(result, this.valueKey);
            // set value
            BewypeJS.Utils.updateField(this.fieldId, _value);
            // ensure picker value
            _value = (MochiKit.Base.isUndefinedOrNull(_value)) ? "#ffffff" : _value;
            // set color picker value
            this.colorPicker.ColorPickerSetColor(_value);    
            // update image color
            jQuery("#" + this.fieldId + "Div div").css("backgroundColor", _value);
            // do not display success message ...
        }
        else
        {
            // pass // nothing to do
        }
    }
});

