
/**
 *
 */
BewypeJS.Component.Entry = new Class(
{
    // parent class
    Extends: BewypeJS.Component,

   /**
     *
     */
    initialize: function (className, widgetId, groupId, valueKey, validator, dateFormat)
    {
        // init parent
        this.actionList = ["Add", "Cancel", "Edit", "Reload", "Update"];
        this.parent(className, widgetId, groupId, valueKey);
        // set the maind field id
        this.fieldId = this.widgetId + "Entry";
        //  set the validator type
        this.validator =
                (MochiKit.Base.isUndefinedOrNull(validator)
                 || MochiKit.Format.strip(validator) == "") ? null : validator;
        this.dateFormat = 
                MochiKit.Base.isUndefinedOrNull(dateFormat)
                ? "y/m/d"
                : dateFormat;
    },

    paramsCb: function (linkElement, params)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            return null;
        }
        else if (_action == "Add"
                || _action == "Update")
        {
            // get value
            var _value = BewypeJS.Utils.getFieldValue(this.fieldId)
            // little check
            if (MochiKit.Base.isUndefinedOrNull(_value))
            {
                return null;
            }
            else if (MochiKit.Base.isUndefinedOrNull(this.validator))
            {
                params[this.valueKey] = _value;
            }
            else if (this.validator == "NotEmpty"
                    && BewypeJS.Validators.validateNotEmpty(this.fieldId))
            {
                params[this.valueKey] = _value;
            }
            else if (this.validator == "Email"
                    && BewypeJS.Validators.validateEmail(this.fieldId))
            {
                params[this.valueKey] = _value;
            }
            else if (this.validator == "Date"
                    && BewypeJS.Validators.validateDate(this.fieldId, this.dateFormat))
            {
                params[this.valueKey] = _value;
            }
            else
            {   
                //  raise an error with the given message
                throw this.msgErrorDict[_action];
            }
            if(_action == "Add")
            {
                return null;
            }
            else
            {
                return params;
            }
        }
        else
        {
            return params;
        }
    }
});

