
/**
 *
 */
BewypeJS.Component.FormChildren = new Class(
{
    // parent class
    Extends: BewypeJS.Component,
    
   /**
     *
     */
    initialize: function (widgetName, widgetId, groupId, valueKey)
    {
        // init parent
        this.actionList = ["Append", "Edit", "Reload", "Remove", "Update"];
        this.parent(widgetName, widgetId, groupId, valueKey);
        // set specific field id
        this.fieldId = this.widgetId + "FormChildren";
        // connect our event handlers right off
        this.initHandler("Append");
        // reload all
        this.doCall("Reload");
    },

    //// RELOAD LIST

    /**
     *
     */
    _initChildrenElement: function ()
    {
        // set a div id
        var _childrenId = this.widgetId + "ChildId";
        // get list element
        var _childrenElmt = MochiKit.DOM.getElement(_childrenId);
        // little check 
        if(MochiKit.Base.isUndefinedOrNull(_childrenElmt))
        {
            // get widget frame element
            var _setupFrameElmt = MochiKit.DOM.getElement(this.widgetId);
            // new list div attrs
            var _attrs = {
                "id": _childrenId,
                "class": this.className
                };
            // create new div
            _childrenElmt = MochiKit.DOM.DIV(_attrs, null);
            // add div to frame
            MochiKit.DOM.appendChildNodes(_setupFrameElmt, _childrenElmt);
        }
        else
        {
            // already exist
        }
    },
    
    /**
     *
     */
    renderChildrenCb: function (className, modelRow)
    {
        // layout display name
        var _displayName = new BewypeJS.Ui.Label(
                    {
                        "class": this.className,
                        "text": modelRow[0]
                    }
                );
        //
        var _removeLink = new BewypeJS.Ui.Label(
                    {
                        "class": this.className + "Remove",
                        "text": "Remove",
                        "href": "#" + className.toLowerCase()
                    }
                );
        // item box
        var _hBox = new BewypeJS.Ui.HBox(
                    {
                        "class": this.className
                    }
                );
        // do add
        _hBox.add(_displayName);
        _hBox.add(_removeLink);
        // return nice list item
        return _hBox.getDocFactory();
    },

    __callAdapter: function (listElement)
    {
        this.doCall("Update", null, listElement);
    },

    /**
     *
     */
    _reloadChildren: function (result)
    {
        // get models from result
        var _comboboxModel = BewypeJS.Utils.getVal(result, "comboboxModel");
        var _childrenModel = BewypeJS.Utils.getVal(result, "childrenModel");

        if(MochiKit.Base.isUndefinedOrNull(_comboboxModel)
            || MochiKit.Base.isUndefinedOrNull(_childrenModel))
        {
            MochiKit.Base.noop();
        }
        else
        {
            // ensure children div
            this._initChildrenElement();
            // reload boxes - both of them
            // some args
            var _textColumn = 0;
            // get combobox id
            var _comboboxId = this.widgetId + "Combobox";
            // update box
            BewypeJS.Utils.Box.updateComboBox(_comboboxId, _textColumn, _comboboxModel);
            // get list element
            var _childrenId = this.widgetId + "ChildId";
            // build mochikit sortable list and replace the current
            BewypeJS.Utils.List.updateSortableList(_childrenId, _childrenModel,
                    this.renderChildrenCb, this.__callAdapter);
        }
    },
    
    _getChildToAppendId: function ()
    {
        // add info
        var _comboboxId = this.widgetId + "Combobox";
        var _comboElmt = MochiKit.DOM.getElement(_comboboxId);

        if(MochiKit.Base.isUndefinedOrNull(_comboElmt))
        {
            MochiKit.Base.noop();
        }
        else
        {
            // get selected layout element name for add and update params
            var _activeResult = BewypeJS.Utils.Box.getComboBoxActive(_comboElmt);
            // return box item id
            return (_activeResult[1] == 0) ? null : _activeResult[0][0];
        }
    },
    
    _getChildId: function (listItem)
    {
        // get firt input element
        var _hiddenElement = MochiKit.DOM.getFirstElementByTagAndClassName(
                "input", null, listItem);
        // return parsed item value
        return _hiddenElement.value;
    },

    //// CALLBACKS

    paramsCb: function (linkElement, params)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            return null;
        }
        else if(_action == "Append")
        {
            // get child to add id
            params["childId"] = this._getChildToAppendId();
        }
        else if(_action == "Remove")
        {
            // get clicked element
            var _listElmt = MochiKit.DOM.getFirstParentByTagAndClassName(
                    linkElement, "li");
            // get child id
            params["childId"] = this._getChildId(_listElmt);
        }
        else if(_action == "Update")
        {
            // get clicked element
            var _listElmt = MochiKit.DOM.getFirstParentByTagAndClassName(
                    linkElement, "li");
            // get child id
            params["childId"] = this._getChildId(_listElmt);
            // get all children elements
            var _listElmts = MochiKit.DOM.getElementsByTagAndClassName(
                    "li", this.className, this.widgetId)
            // get the sorted list for update
            params["sortedList"] = MochiKit.Base.map(this._getChildId, _listElmts);
        }
        else
        {
            // pass // nothing to do
        }
        // always return the params dict for the rpc call
        return params;
    },

    resultCb: function (linkElement, params, result)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            // ?? pass
            return false;
        }
        else if(_action == "Edit"
                || _action == "Reload")
        {
            // reload children
            this._reloadChildren(result);
            // init handlers
            this.initLinkHandlers("Remove");
        }
        else
        {
            // pass // nothing to do
        }
    }
});

