
/**
 *
 */
BewypeJS.Component.List = new Class(
{
    // parent class
    Extends: BewypeJS.Component,
   /**
     *
     */
    initialize: function (className, widgetId, groupId, valueKey)
    {
        // init parent
        this.actionList = ["Delete", "Reload"];
        this.parent(className, widgetId, groupId, valueKey);
        this.fieldId = this.widgetId + "TreeView";
        // init handlers
        MochiKit.Base.map(this.initLinkHandlers, ["Delete", "Edit"]);
        // get data table
        this.dataTable = this.getDataTable();
    },

    getDataTable: function ()
    {
        var _option = { "sPaginationType": "full_numbers" };
        return new jQuery("#" + this.fieldId).dataTable(_option);
    },

    //// TREEVIEW RELOADING

    addColumn: function (treeView, args, key)
    {
        // parse args
        var _class = BewypeJS.Utils.getVal(args[key], "class_");
        var _title = BewypeJS.Utils.getVal(args[key], "title");
        var _kargs = BewypeJS.Utils.getVal(args[key], "kargs");
        // cell renderer
        var _cellRenderer = new BewypeJS.Ui.CellRendererText(
                    {
                        "class": _class
                    }
                );
        // create column
        var _tvColumn = new BewypeJS.Ui.TreeViewColumn(
                    {
                        "title": _title
                    }
                );
        // set column
        _tvColumn.packStart(_cellRenderer);
        //
        var _keys = MochiKit.Base.keys(_kargs);
        //
        for(var _i=0; _i<_keys.length; _i++)
        {
            var _key = _keys[_i];
            _tvColumn.addAttribute(_cellRenderer, _key, _kargs[_key]);
        }
        // add the new column to the treeview
        treeView.appendColumn(_tvColumn);
    },
    
    /**
     *
     */
    getTreview: function (keyList, argsList, model)
    {
        // treeview init
        var _treeview = new BewypeJS.Ui.TreeView(
                                {
                                    "id": this.fieldId,
                                    "class": this.className,
                                    "model": model
                                }
                            );
        // prepare add func
        var _addColumnFunc = MochiKit.Base.partial(
                this.addColumn, _treeview, argsList);
        // do map
        MochiKit.Base.map(_addColumnFunc, keyList);
        // return the update treeview at the end
        return _treeview;
    },

    ////

    paramsCb: function (linkElement, params)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            return null;
        }
        else if(_action == "Delete"
                || _action == "Reload"
                || _action == "Update")
        {
            return params
        }
        else
        {
            return null;
        }
    },

    resultCb: function (linkElement, params, result)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            // ?? pass
            return false;
        }
        else if(_action == "Delete")
        {
        }
        else if(_action == "Reload")
        {
            // get class name
            var _hiddenFieldName = this.widgetId + "HiddenItemId";
            var _hiddenFieldElmt = MochiKit.DOM.getElement(_hiddenFieldName);
            // parse listing result
            var _keyList = BewypeJS.Utils.getVal(result, "keyList");
            var _argsList = BewypeJS.Utils.getVal(result, "argsList");
            var _model = BewypeJS.Utils.getVal(result, "model");
            // get new trreview
            var _treeview = this.getTreview(_keyList, _argsList, _model);
            // recreate e new div
            var _newDivElement = MochiKit.DOM.DIV(
                        {
                            "id": this.widgetId,
                            "class": this.className,
                        }
                    );
            MochiKit.DOM.swapDOM(this.widgetId, _newDivElement);
            // append hidden field and new table
            MochiKit.DOM.appendChildNodes(
                    _newDivElement,
                    _hiddenFieldElmt,
                    _treeview.getDocFactory()
                    );
            // connect our event handlers right off
            this.initLinkHandlers("Edit");
            this.initLinkHandlers("Delete");
            // little check
            if (_model.length == 0)
            {
                return;
            }
            else
            {
                // get data table
                this.dataTable = this.getDataTable();
            }
        }
        else
        {
            // pass // nothing to do
        }
    }
});

