
/**
 *
 */
BewypeJS.Component.MenuVertical = new Class(
{
    // parent class
    Extends: BewypeJS.Component,

   /**
     *
     */
    initialize: function (className, widgetId, groupId, valueKey)
    {
        // init parent
        this.actionList = ["Edit", "Reload"];
        this.parent(className, widgetId, groupId, valueKey);
        // set the maind field id
        this.fieldId = this.widgetId + "Menu";
        //
        this.resetMenu();
    },

    toggleCb: function (ulElmt, imgElmt)
    {
        // get first child
        var _liElmt = MochiKit.DOM.getFirstElementByTagAndClassName("li", this.className, ulElmt);

        if (MochiKit.Base.isUndefinedOrNull(_liElmt)
            || MochiKit.Base.isUndefinedOrNull(ulElmt))
        {
            // do nothing
        }
        else
        {
            // get visible flag
            var _dimension = MochiKit.Style.getElementDimensions(_liElmt);
            // image check
            if (MochiKit.Base.isUndefinedOrNull(imgElmt))
            {
            }
            else
            {
                // image update
                imgElmt.src = (_dimension["h"] == 0)
                    ? "#"
                    : "#"; // down or right arrow
            }
            // prepare toggle method
            MochiKit.Visual.toggle(ulElmt, "blind");
        }
    },

    setCb: function (liElmt)
    {
        // get corresponding span for signal
        var _spanElmt = MochiKit.DOM.getFirstElementByTagAndClassName("span", null, liElmt);
        //
        var _ulElmt = MochiKit.DOM.getFirstElementByTagAndClassName("ul", this.className, liElmt);
        var _imgElmt = MochiKit.DOM.getFirstElementByTagAndClassName("img", null, liElmt);
        // prepare toggle func
        var _toggleFunc = MochiKit.Base.partial(this.toggleCb, _ulElmt, _imgElmt)
        // connect
        MochiKit.Signal.connect(_spanElmt, "onclick", _toggleFunc);
    },

    resetMenu: function ()
    {
        // get event triggers
        var _liElmts = MochiKit.DOM.getElementsByTagAndClassName("li", this.className + "Dir", this.fieldId);
        // set signals
        MochiKit.Base.map(this.setCb, _liElmts);
        // rounded it
        MochiKit.Visual.roundElement(this.fieldId, {corners: "all"});
     },

    resultCb: function (linkElement, params, result)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            // ?? pass
        }
        else if (_action == "Edit"
                || _action == "Reload")
        {
            // get value
            var _value = BewypeJS.Utils.getVal(result, this.valueKey);
            // set value
            BewypeJS.Utils.updateField(this.fieldId, _value);
            //
            this.resetMenu();
        }
        else
        {
            // pass // nothing to do
        }
    }
});

