
/**
 *
 */
BewypeJS.Component = new Class(
{

   /**
    *
    */
    initialize: function (className, widgetId, groupId, valueKey)
    {
        //
        this.className = className;
        this.widgetId = widgetId;
        this.groupId = groupId;
        this.valueKey = valueKey;
        // ensure actionList
        if (MochiKit.Base.isUndefinedOrNull(this.actionList))
        {
            this.actionList = []; 
        }
        else
        {
            // pass
        }
        //
        BewypeJS.Utils.Widget.updateGroups(this.groupId, this);
        //
        this.fieldId = widgetId; // should be overriden
        // message dict
        this.msgSuccessDict = {
            "Add": "Add done sucessfully!",
            "Update": "Update done sucessfully!",
            "Delete": "Delete done sucessfully!"
        };
        //
        this.msgErrorDict = {
            "Add": "Add failed!",
            "Update": "Update failed!",
            "Delete": "Delete failed!"
        };
        //
        MochiKit.Base.bindMethods(this);
    },

    getMessageField: function ()
    {
        return this.fieldId; // should be overriden
    },

    //// INIT HANDLERS

    /**
     *
     */
    _connectLink: function (action, link)
    {
        // ensure valid id
        var _id = (MochiKit.Base.isUndefinedOrNull(link.name)
                || MochiKit.Format.strip(link.name) == "") ? null : link.name;
        // prepare edit func
        var _doCallFunc = MochiKit.Base.partial(
                this.doCall, action, _id, link);
        // set edit handler
        MochiKit.Signal.connect(link, "onclick", _doCallFunc);
    },

    initLinkHandlers: function (action)
    {
        // get all the to manage edit callbacks
        var _links = MochiKit.DOM.getElementsByTagAndClassName(
                "a", this.className + action, this.widgetId);
        // littel check
        if (MochiKit.Base.isUndefinedOrNull(action)
            || MochiKit.Base.isUndefinedOrNull(_links))
        {
            // ?? pass
        }
        else
        {
            // disconnect all first
            MochiKit.Base.map(MochiKit.Signal.disconnectAll, _links);
            // prepare connect func
            var _connectFunc = MochiKit.Base.partial(this._connectLink, action);
            // do connect
            MochiKit.Base.map(_connectFunc, _links);
        }
    },

    initHandler: function (action)
    {
        // get elements info
        var _buttonElmt = MochiKit.DOM.getElement(this.widgetId + action + "Button");
        // little check
        if (MochiKit.Base.isUndefinedOrNull(_buttonElmt))
        {
            // pass
        }
        else
        {
            // disconnect all first
            MochiKit.Signal.disconnectAll(_buttonElmt);
            // prepare edit func
            var _doCallFunc = MochiKit.Base.partial(
                    this.doCall, action, null, _buttonElmt);
            // set edit handler
            MochiKit.Signal.connect(_buttonElmt, "onclick", _doCallFunc);
        }
    },

    //// DEFAULT RESULT CB

    paramsCb: function (linkElement, params)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        // get value
        var _value = BewypeJS.Utils.getFieldValue(this.fieldId);
        //
        if (MochiKit.Base.isUndefinedOrNull(_action)
            || MochiKit.Base.isUndefinedOrNull(_value))
        {
            return null;
        }
        else if (_action == "Add")
        {
            // just update the current params dict
            params[this.valueKey] = _value;
            return null;
        }      
        else if(_action == "Update")
        {
            // update and return
            params[this.valueKey] = _value;
            return params;
        }
        else
        {
            return params;
        }
    },

    resultCb: function (linkElement, params, result)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action)
            || MochiKit.Base.isUndefinedOrNull(result))
        {
            // ?? pass
        }
        else if (_action == "Cancel"
                || _action == "Edit"
                || _action == "Reload")
        {
            // get value
            var _value = BewypeJS.Utils.getVal(result, this.valueKey);
            // set value
            BewypeJS.Utils.updateField(this.fieldId, _value);
        }
        else if (_action == "Add")
        {
            // always update current id
            var _itemId = BewypeJS.Utils.getVal(result, "itemId");
            if (MochiKit.Base.isUndefinedOrNull(_itemId)
                || MochiKit.Format.strip(_itemId) == "")
            {
                // pass
            }
            else
            {
                // update uploaders ..
                MochiKit.Base.map(
                        MochiKit.Base.partial(BewypeJS.Utils.Widget._updateComponentId, _itemId),
                        BewypeJS.Utils.Widget.getUploaders(this.groupId));
                MochiKit.Base.map(
                        MochiKit.Base.partial(BewypeJS.Utils.Widget._updateComponentId, _itemId),
                        BewypeJS.Utils.Widget.getCheckers(this.groupId));
                MochiKit.Base.map(
                        MochiKit.Base.partial(BewypeJS.Utils.Widget._updateComponentId, _itemId),
                        BewypeJS.Utils.Widget.getComponents(this.groupId));
            }
        }
        else
        {
            //
        }
    },

    confirmDeleteCb: function (linkElement, params)
    {
        // TODO get i18n text from template
        return confirm("Please confirm item removal?");
    },

    //// PARAMS CALLBACK

    /**
     *
     */
    paramsCallBack: function (linkElement, params)
    {
        // get current action
        var _action = BewypeJS.Utils.getVal(params, "action");
        // little check
        if (_action == "Edit"
            || _action == "Reload")
        {
            // always update current id
            var _itemId = BewypeJS.Utils.getVal(params, "itemId");
            this._updateItemId(_itemId);
        }
        else if (MochiKit.Base.isUndefinedOrNull(_action)
            || MochiKit.Base.findValue(this.actionList, _action) == -1)
        {
            return null;
        }
        else if (_action == "Delete")
        {
            if (this.confirmDeleteCb(linkElement, params))
            {
                // pass
            }
            else
            {
                // stop current action
                return null;
            }
        }
        else
        {
        }
        // get current params
        return this.paramsCb(linkElement, params);
    },

    /**
     *
     */
    resultCallBack: function (linkElement, params, result)
    {
        // get values
        var _error = BewypeJS.Utils.getVal(result, "error");
        var _message = BewypeJS.Utils.getVal(result, "message");
        //
        if(MochiKit.Base.isUndefinedOrNull(_error)
            || MochiKit.Base.isUndefinedOrNull(_message))
        {
            // ?? invalid widget
            return null;
        }
        else if (_error == true)
        {
            //  raise an error with the given message
            throw _message;
        }
        return this.resultCb(linkElement, params, result)
    },

    /**
     *
     */
    finalCallBack: function (linkElement, params, result)
    {
        // get values
        var _action = BewypeJS.Utils.getVal(params, "action");
        // TODO check result type -> should an error
        if (!MochiKit.Base.isUndefinedOrNull(result))
        {
            // append a success message
            BewypeJS.Utils.Widget.appendMessage(
                    this.getMessageField(), "Error", result.message);
        }
        else if (_action == "Add"
                || _action == "Append"
                || _action == "Delete"
                || _action == "Remove"
                || _action == "Update")
        {
            // get success message
            var _msg = this.msgSuccessDict[_action];
            // append a success message
            BewypeJS.Utils.Widget.appendMessage(
                    this.getMessageField(), "Success", _msg);
            // reload after work
            this.doCall("Reload", null, linkElement);
        }
        else
        {
            // what else!
        }
    },

    errorCallBack: function (linkElement, params, err)
    { 
        // append an error message
        BewypeJS.Utils.Widget.appendMessage(
                this.getMessageField(), "Error", err.message);
        // get values
        var _action = BewypeJS.Utils.getVal(params, "action");
        // an exception for the caller
        throw this.msgErrorDict[_action];
    },

    //// ITEM ID

    /**
     *
     */
    _getItemId: function ()
    {
        // get class name
        var _hiddenFieldName = this.widgetId + "HiddenItemId";
        var _hiddenFieldElmt = MochiKit.DOM.getElement(_hiddenFieldName);
        // for item name if passed in parameter
        if (MochiKit.Base.isUndefinedOrNull(_hiddenFieldElmt))
        {
            // get current item name
            return null;
        }
        else
        {
            // return value
            return _hiddenFieldElmt.value;
        }
    },

    /**
     *
     */
    _updateItemId: function (itemId)
    {

        // for item name if passed in parameter
        if (MochiKit.Base.isUndefinedOrNull(itemId))
        {
            // do nothing
        }
        else
        {
            // get class name
            var _hiddenFieldName = this.widgetId + "HiddenItemId";
            // update field
            BewypeJS.Utils.updateField(_hiddenFieldName, itemId);
        }
    },

    //// WIDGET CALLS

    _enqueueCheckers: function (deferred, params, linkElment)
    {
        // get current checkers
        var _checkers = BewypeJS.Utils.Widget.getCheckers(this.groupId);
        // prepare call func
        var _callFunc = MochiKit.Base.partial(
                this.__rpcCall, deferred, params, linkElment);
        // map to deferred calls
        MochiKit.Base.map(_callFunc, _checkers);
    },

    _enqueueUploaders: function (deferred, params, linkElment)
    {
        // get current uploaders
        var _uploaders = BewypeJS.Utils.Widget.getUploaders(this.groupId);
        // prepare call func for uploads
        var _callFunc = MochiKit.Base.partial(
                this.__rpcCall, deferred, params, linkElment);
        // map to deferred calls
        MochiKit.Base.map(_callFunc, _uploaders);
    },

    _enqueueComponents: function (deferred, params, linkElment)
    {
        // get current components
        var _components = BewypeJS.Utils.Widget.getComponents(this.groupId);
        // prepare call func
        var _callFunc = MochiKit.Base.partial(
                this.__rpcCall, deferred, params, linkElment);
        // map to deferred calls
        MochiKit.Base.map(_callFunc, _components);
    },

    __rpcCall: function (deferred, params, linkElment, component)
    {
        // get requested action
        var _action = BewypeJS.Utils.getVal(params, "action");
        // get secured rpc url
        var _rpcUrl = BewypeJS.Utils.getRpcUrl(component.widgetId + _action);
        // init login handler
        var _rpcHandler = new BewypeJS.Rpc.Handler(
                _rpcUrl,
                component.paramsCallBack,
                component.resultCallBack,
                component.errorCallBack
                );
        // do log
        deferred.addCallback(_rpcHandler.doCall, linkElment, params);
    },

    /**
     * Direct call.
     */
    doCall: function (action, itemId, linkElment)
    {
        // ensure itemId first
        itemId = MochiKit.Base.isUndefinedOrNull(itemId) ?
            this._getItemId() : itemId;
        // prepare params
        var _params = {
            "action": action,
            "itemId": itemId
        };
        // create a new deferred
        var _d = new Deferred();
        // prepare checkers
        if (action != "Cancel"
                && action != "Edit"
                && action != "Reload")
        {
            // prepare params
            var _checkParams = {
                "action": "Check",
                "itemId": itemId
            };
            // enqueue checkers
            this._enqueueCheckers(_d, _checkParams, linkElment);
        }
        else
        {
            // enqueue checkers
            this._enqueueCheckers(_d, _params, linkElment);
        }
        // current action
        if (action == "Delete")
        {
            this.__rpcCall(_d, _params, linkElment, this);
        }
        else
        {
            // enqueue checkers
            this._enqueueComponents(_d, _params, linkElment);
            // enqueue checkers
            this._enqueueUploaders(_d, _params, linkElment);
        }
        // add final result call back
        _d.setFinalizer(this.finalCallBack, linkElment, _params);
        // start
        _d.callback();
    },
    
    updateParams: function (linkElement, params)
    {
        // little check
        if (MochiKit.Base.isUndefinedOrNull(this.groupId))
        {
            // nothing to reload
            return params;
        }
        else
        {
            // prepare func
            return BewypeJS.Utils.Widget.updateParams(linkElement, this, params);
        }
    },
});

